/*****************************************************************************
 
            Copyright (c)2007 Geovariances, Avon, France.
 
    In consideration  of payment of  the license fee,  which is a part of
    the price you  paid for this  product, Geovariances (GV) as licensor,
    grants you, the licensee, a non-exclusive right to use this copy of a
    GV software product.
    GV reserves all rights not  expressly granted to licensee. GV retains
    titleship and ownership  of software.  This license is not  a sale of
    the original  software or any  copy. GV also  retains  titleship  and
    ownership of any modifications or  derivations of this software.  Any
    modifications of this software  must be clearly marked as such.  This
    copyright message must  appear in its entirety  in this software,  or
    any modifications or derivations thereof.
 
    Geovariances welcomes any comments, suggestions, bug reports, etc. At
    the discretion  of Geovariances,  any customer  supplied  bug  fixes,
    enhancements, or utility codes will be distributed in future software
    releases (the contributor will of course be credited).
 
            Geovariances
            49bis, Avenue Franklin Roosevelt
            77210 Avon, FRANCE
 
             Phone: +33-(0)-160.749.100
               Fax: +33-(0)-164.228.728
            e-mail: support@geovariances.fr
 
                        All Rights Reserved
 
*****************************************************************************/
 
#include <GTXClientP.h>

static char svnid[] _GTX_UNUSED = "$Id: init_client.c 11469 2008-01-02 11:59:12Z foucher $";

#include <signal.h> /* signal() */
#include <string.h> /* memcpy() */
#ifndef winnt
#include <unistd.h>  /* close() */
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#endif

_GTX_SOCKET _gtx_server_socket = _GTX_SOCKET_ERROR;

/* As GTXClient library is shared between the server and the client, this
   variable will tell us where we are */
int _gtx_is_server = 0;

#if 0
/***************************************************************************
**
** FUNCTION:    st_handle_broken_pipe
**
** DESCRIPTION: Handler for broken_pipe signal generated by a disconnection
**
** RETURNS:     Nothing
**
** ARGUMENTS:   int signal : signal (Broken PIPE)
**
** REMARKS:     signal must be re-declared on some plateforms
**
***************************************************************************/
static void st_handle_broken_pipe(int sig)
{
  _gtx_error("Received BrokenPipe signal");
#if defined(hpux) || defined(solaris) || defined(irix) || defined(aix)
  (void)signal(SIGPIPE, st_handle_broken_pipe);
#endif
}
#endif

/***************************************************************************
**
** FUNCTION:    _gtx_init_client
**
** DESCRIPTION: connect the client to the server
**
** RETURNS:     int error   : error_code : 0 if Ok, !0 elsewhere
**
** ARGUMENTS:   char *host : server name or ip adress
** ARGUMENTS:   unsigned short port     : server port
**
***************************************************************************/
int _gtx_init_client(const char *host, unsigned short port)
{
  int err;

  if ((err = _gtx_connect(host, port, &_gtx_server_socket)))
    return(err);

#if !defined(winnt)
  /*(void)signal(SIGPIPE, st_handle_broken_pipe);*/
  (void)signal(SIGPIPE, SIG_IGN);
#endif
  return(0);
}
